### Method

# Hinawa FwReq transaction

since: 4.0

#### Declaration [src]

    gboolean
    hinawa_fw_req_transaction (
      HinawaFwReq* self,
      HinawaFwNode* node,
      HinawaFwTcode tcode,
      guint64 addr,
      gsize length,
      guint8** frame,
      gsize* frame_size,
      guint timeout_ms,
      GError** error
    )

#### Description [src]

Execute request subaction of transaction to the given node according to given code, then wait for response subaction within the value of timeout argument. The function is a thin wrapper to `hinawa_fw_req_transaction_with_tstamp()`.

Available since: 4.0

#### Parameters

`node`

  Type: `HinawaFwNode`

  A `HinawaFwNode`.

  The data is owned by the caller of the method.

`tcode`

  Type: `HinawaFwTcode`

  A transaction code of `HinawaFwTcode`.

`addr`

  Type: `guint64`

  A destination address of target device.

`length`

  Type: `gsize`

  The range of address in byte unit.

`frame`

  Type: An array of `guint8*`

  An array with elements for byte data. Callers should give it for buffer with enough space against the request since this library performs no reallocation. Due to the reason, the value of this argument should point to the pointer to the array and immutable. The content of array is mutable for read and lock transaction.

  The argument will be modified by the function.
  The length of the array is specified in the `frame_size` argument.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`frame_size`

  Type: `gsize*`

  The size of array in byte unit. The value of this argument should point to the numerical number and mutable for read and lock transaction.

  The argument will be modified by the function.

`timeout_ms`

  Type: `guint`

  The timeout to wait for response subaction of the transaction since request subaction is initiated, in milliseconds.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

TRUE if the overall operation finishes successfully, otherwise FALSE.